""" The pdelab specific parts of the code generation process """

# Define the generators that are used throughout all pdelab specific code generations.
from dune.perftool.generation import symbol, generator_factory
from dune.perftool.loopy.transformer import quadrature_iname
from loopy import CInstruction


def quadrature_preamble(assignees=[]):
    # TODO: How to enforce the order of quadrature preambles? Counted?
    return generator_factory(item_tags=("instruction", "cinstruction"), on_store=lambda code: CInstruction(quadrature_iname(), code, assignees=assignees))


# Now define some commonly used generators that do not fall into a specific category
@symbol
def name_index(index):
    return str(index._indices[0])
